docker-build-master:
  image: docker:latest
  stage: build
  services:
    - docker:dind

  before_script:
    #  predefined variables in gitlab  => CI

    # Create a tag using the commit and the job ID  => the tag will be the name of the container
    - export TAG=${CI_COMMIT_SHORT_SHA}-${CI_JOB_ID}

    # Login into the containers registry
    - docker login $CI_REGISTRY -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" 
    # the -u and -p is created in this instand and will be destroid when the pipeline finish it execution

  script:
    # Build and push the real image
    - docker build -t $CI_REGISTRY/${CI_PROJECT_PATH}:$TAG .
    - docker push $CI_REGISTRY/${CI_PROJECT_PATH}:$TAG

    # Retag and push the image to have a latest tag
    - docker tag $CI_REGISTRY/${CI_PROJECT_PATH}:$TAG $CI_REGISTRY/${CI_PROJECT_PATH}:latest
    - docker push $CI_REGISTRY/${CI_PROJECT_PATH}:latest
  only:
  # it is going the executed only if there is a change in the master branch
    - master